$TEXT (NAM=PRC:CRE_PRCINI, ATT=ASC)
~KWD=(NA1,NAM,NA2,VL2,NA3,VL3,NA4,VL4,NA5,VL5,NA6,VL6,NA7,VL7,NA8,VL8,INQ,PRC)
~ATY=(QUE,STR,QUE,STR,QUE,STR,QUE,STR,QUE,STR,QUE,REA,QUE,STR,QUE,REA,STR,NAM)
~DEF='PRCINI (NA1=~NEU,INQ=N,PRC=PRCINI)'
!
!  Befehl erstellen
DFNKWD PRCINI, 1745, , , PRCINI, , ~KWD, ~ATY, ~DEF

CnvTxtToXml     (TXT=PRCINI$DLP, XML=DLP:PRCINI)

$TXTEND
$TEXT (NAM=PRC:PRCINI, ATT=ASC)
!---------------------------------------------------------
!   Inhalt der Procedur PRCINI
!---------------------------------------------------------
! VO.1 13.04.2004
! R2, JW, Jan. 2020
!
! verwendete Variablen:
! ~NEU = Name der neuen PRC aus Maske 
!
! Fragezeichen ? Platzhalter innerhalb der MSK und PRC aus der UDB
! Anweisungstext zum Vorbereiten des Maskentextes
DELTXT ZWISCHEN, N
CPYTXT PRCINI$MSK, ZWISCHEN
RPLSTR ZWISCHEN, ?, ~NEU
RENAME ZWISCHEN, ~NEU, TXT
!
!  Anweisungstext zur Befehlserstellung 
!  Vorlage aus der UDB
CPYTXT    (FRM=PRCINI$PRC, TO =ZWISCHEN)
!
RPLSTR ZWISCHEN, ?, ~NEU
!  EDTTXT ZWISCHEN
! 
CPYPRC TXT:ZWISCHEN, PRC:PRCINI$BFR
DELCHS ~NEU, N
DELTXT ZWISCHEN, N

INSPRC          (TXT=PRCINI$BFR, EOB=Y, FRA=99)
! Mit EXECKEY in BASE springen und DELETE Buffer einfuegen;
! STOP muss vorhanden sein, um EXECKEY zu aktivieren!
!---------------------------------------------------------------------
$TXTEND
$TEXT (NAM=TXT:PRCINI, LMG=1)
$MASK (NAM=PRCINI, CPY=INPUTSTR, BGN=1, END=17, TMG=5, BMG=15, PRM=N)
$LINEATT,GRA
                       lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
                       x      PRCINI - ANWEISUNGS               x
                       x             GENERATOR                  x
                       mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj
$LINEATT,GRA

$LINEATT,ASC
Anweisung                               = $222222$
$LINEATT,ASC

$LINEATT,ASC
Name der neuen Anweisung          (NAM) = $4444444444444444444444444444444444$
$MSKHELP (FLD=$4, HLP=PRCINI, TYP=INCH)
$MSKEND


$TXTEND
$MASK (NAM=PRCINI, CPY=PRCINI, BGN=1, END=17, TMG=5, BMG=15, PRM=N)
$LINEATT,GRA
                       lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
                       x      HILFE ZUM ERSTELLEN VON NEUEN     x
                       x              ANWEISUNGEN               x
                       mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj

$LINEATT,ASC
Anweisung                               = $222222$

Name der neuen Anweisung          (NAM) = $4444444444444444444444444444444444$
$MSKHELP (FLD=$2, HLP=INPUTSTR, TYP=INCH)
$MSKHELP (FLD=$4, HLP=PRCINI, TYP=INCH)
$MSKEND
$TEXT (NAM=HLP:PRCINI, ATT=ASC, LMG=21174216)
PRCINI
 - Hilfswerkzeug; in 6 Schritten zur Anweisung

Wichtig zu Beginn:
Funktion und Umfang sollte bereits in groben Zgen vorhanden sein.

           -- Keep it Small and Simple --


   NAM = Name der Anweisung; Durch Ausfhren wird die aus der Vorlage
         Maske und Text im Base zur Verfgung gestellt



Schritt 0    Programmierung der Anweisung bzw. Procedur, die durch
             die Anweisung gestartet wird.
             Der Einfachheit halber immer am Ende.
             (mit Gold 999 Delete alles in Delete Buffer kopieren)


Schritt 1    Maskentext definieren
             berflssige Felder lschen, Default Zeilen mit Text fllen
             im oberen Bereich GROSS schreiben, unten ist auch klein mglich
             in den Klammern geeignete Schlsselwrter (3 Zeichen) 

Schritt 2    Helptext verfassen; Quindos konform    

Schritt 3    Schlsselwrter definieren;     
             Text direkt in Base beachten; 

Schritt 4    Erstellen einer Hilfsprocedur, die alle notwendigen    
             Elemente, Texte und Symbole erstellt
             (Wird in der UDB ausgefhrt, nach einlesen der Datei)
               -> siehe Schritte in UDB, oder alt. in GDB

Schritt 5    Ende Schritt 0, wenn die Procedur als solches fertig ist,    
             Inhalt in PRC kopieren

Schritt 6    Exportieren aller Objekte in Datei, die Betriebssystem und 
             QuindosVersion unabhngig einsetzbar ist.
             -> Diese Datei wird in UDB importiert!
             Aktuelle Datei immer klar bezeichnen, damit Import
             automatisiert abluft.

                                          joerg weisser, messtronik Apr 04
$TXTEND
$TEXT (NAM=TXT:PRCINI$MSK, LMG=1)
$MASK (NAM=?, CPY=INPUTSTR, BGN=1, END=17, TMG=5, BMG=15, PRM=N)
$LINEATT,GRA
                       lqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqk
                       x       ?  - ANWEISUNG             x
                       x                                        x
                       mqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqj
$LINEATT,GRA

$LINEATT,ASC
Anweisung                               = $222222$
$LINEATT,ASC

$LINEATT,ASC
String, der <NAM> zugewiesen wird (VAL) = $4444444444444444444444444444444444$
String, der <NA2> zugewiesen wird (VL2) = $6666666666666666666666666666666666$
String, der <NA3> zugewiesen wird (VL3) = $8888888888888888888888888888888888$
String, der <NA4> zugewiesen wird (VL4) = $0000000000000000000000000000000000$
String, der <NA5> zugewiesen wird (VL5) = $BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB$
String, der <NA6> zugewiesen wird (VL6) = $DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD$
String, der <NA7> zugewiesen wird (VL7) = $FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF$
String, der <NA8> zugewiesen wird (VL8) = $HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH$
$MSKHELP (FLD=$2, HLP=?, TYP=INCH)
$MSKHELP (FLD=$4, HLP=?, TYP=INCH)
$MSKHELP (FLD=$6, HLP=?, TYP=INCH)
$MSKHELP (FLD=$8, HLP=?, TYP=INCH)
$MSKHELP (FLD=$0, HLP=?, TYP=INCH)
$MSKHELP (FLD=$B, HLP=?, TYP=INCH)
$MSKHELP (FLD=$D, HLP=?, TYP=INCH)
$MSKHELP (FLD=$F, HLP=?, TYP=INCH)
$MSKHELP (FLD=$H, HLP=?, TYP=INCH)
$MSKEND
$TXTEND
$TEXT (NAM=TXT:PRCINI$PRC, ATT=ASC, LMG=21174216)
!-----------------------------------------------------------------------------
! ?
! Datum  :           Creator:
! Aufgabe:
!-----------------------------------------------------------------------------
! Index und Art der Aenderung
! V1
!
!
STOP
! Bitte aktuelle Version, nur mit direkter Bezeichnung speichern
SAVE , , , , , , , \\10.10.0.11\tools\AnwendungsProgramme\Quindos\PROCEDUR\?.WDB
!
! Schritt 0 ;-)
!  Definieren der eigentlichen Anweisung; immer am Enden einfuegen
!  definieren; Wieviel Variablen sollen benutzt werden
!
! Schritt 1
!  Maskentext anpassen und in Maske umwandeln
EDTTXT ?
CNVTXT ?
!
! verknuepfen der Variablen zu DLP Elemente wie Textbox etc, Rechtsklick lokales Bindung; Feldbezeichner siehe in Maskenbzeichnung
! am besten Du kopierst ein DLP mit Logo etc. aus der UDB: Wunsch automatisiertes Erzeugen eines DLP mit TXT to XML
EDIT            (NAM=?, TYP=DLP)
!
! Konvertieren, um das Obj als TXT in eine Textdatei zu exportieren
CnvXmlToTxt     (XML=DLP:?, TXT=TXT:?$DLP)
!
! Schritt 2
!  Helptext verfassen
EDTHLP ?
!
! Schritt 3
!  Zurordnen der Elemente zu einer Maske bzw. Anweisung
!  in KWD; VLn setzen der Feldbezeichner, die in d. Maske innerhalb der
!         Klammern stehen
!  in ATY; STR = 1 CHS, STR.= Aufzaehlung von CHS, REA = Realvariable
!  in DEF; zuweisen der Var.namen die dann in der PRC verwendet werden
!         zustzlich setzen von Defaultwerten, die bei Nichtausfuellen 
!         gesetzt werden; Z.B. NAM='EDGAR'
~KWD=(NA1,VL1,NA2,VL2,NA3,VL3,NA4,VL4,NA5,VL5,NA6,VL6,NA7,VL7,NA8,VL8,INQ,PRC)
~ATY=(QUE,STR.,QUE,STR,QUE,STR,QUE,STR,QUE,STR,QUE,REA,QUE,STR,QUE,REA,STR,NAM)
~DEF='? (NA1='',NA2='',NA3='',NA4='',INQ=N,PRC=?)'
! NA1='~Variablenname', Beachte den Unterschied zwischen QUE STR. ohne Punkt
! unter ~DEF werden auch die Defaults der Feldbezeichner gesetzt, wenn keine Eingabe erfolgt.

!  Befehl erstellen
DFNKWD ?, 1745, , , ?, , ~KWD, ~ATY, ~DEF
CnvTxtToXml     (TXT=?$DLP, XML=DLP:?)
!
! Schritt 4
!  Die Anweisunszeilen von ~KWD bis DFNKWD in PRC CRE_? kopieren
!  Aufgabe: Anweisung erstellen mit INDPRC CRE_? zB. in der UDB
EDTPRC CRE_?
!
! Schritt 5
!  Die selbsterstellte Procedur nach PRC ? kopieren
EDTPRC ?
!
! Schritt 6
!  Ausgeben der Anweisungsbestandteile 
!  fuer Einbindung in UDB, oder Export
!  Diese Datei wird mit all Ihrer Bestandteile an die UDB gehaengt
!  Beachten falls zusaetzliche Elemente noetig sind wie TXTs oder MSKs
FMTOBJ          (FIL='\\10.10.0.11\tools\AnwendungsProgramme\Quindos\PROCEDUR\?.PRC', NAM=(PRC:CRE_?,PRC:?,TXT:?,MSK:?,HLP:?,TXT:?$DLP))
!
! Einfuegen der Anweisung in die UDB oder hnlich
! Importiere die Text-Datei ?.PRC lokal in die LDB mit CNVFIL
! Aktivieren mit

CNVFIL          (FIL='\\10.10.0.11\tools\AnwendungsProgramme\Quindos\PROCEDUR\?.PRC')
INDPRC CRE_?

! Kurzanleitung zum Einfgen in die UDB, einfach ffnen der UDB in die LDB
CUTDBS          (DBS=UDB)
OPENWDB          (FIL=\\..\Quindos7.UDB)
CPYOBJ          (FRM='PRC:CRE_?,PRC:?,TXT:?,MSK:?,HLP:?,TXT:?$DLP', TO ='PRC:CRE_?,PRC:?,TXT:?,MSK:?,HLP:?,TXT:?$DLP', SRC=WDB, DST=LDB)
BOOT            (FIL=\\..\Quindos7.Udb, DBS=UDB)

!
!-----------------------------------------------------------------------------


STOP
! Beginn der eigentlichen Anweisung
!==================================
!-----------------------------------------------------------------------------
!
!!  ?
!
!-----------------------------------------------------------------------------
! V1 Datum, Ersteller

! verwendete Variablen Namen
! Zur Sicherheit mit $ abschliessen, um Namensgleichheit in Hauptprogramm
! Verwende nicht Variablen wie I, erzeuge eindeutige Variablen wie ?$name oder ?$i


! loescht temporaere Variablen
! Achtung falls Inhalte fuer weitere Bearbeitung erzeugt werden
CLEANUP
$TXTEND
$TEXT (NAM=TXT:PRCINI$DLP)
<?xml version="1.0" encoding="utf-16"?>
<Root>
  <Dialog QdsName="LDBDLP:PRCINI">
    <BackColor>ControlLightLight</BackColor>
    <NativeFont Name="Microsoft Sans Serif" Size="8.25" Style="Regular" Unit="Point" />
    <ForeColor>ControlText</ForeColor>
    <Size>
      <Width>600</Width>
      <Height>500</Height>
    </Size>
    <GroupBox DsgName="gbx1">
      <AutoSize>False</AutoSize>
      <BackColor>ControlLightLight</BackColor>
      <NativeFont Name="Microsoft Sans Serif" Size="8.25" Style="Regular" Unit="Point" />
      <ForeColor>ControlText</ForeColor>
      <Location>
        <X>25</X>
        <Y>140</Y>
      </Location>
      <Size>
        <Width>530</Width>
        <Height>165</Height>
      </Size>
      <TabIndex>5</TabIndex>
      <TextBox DsgName="tbx1" InputPatternType="None">
        <BackColor>Window</BackColor>
        <BorderStyle>Fixed3D</BorderStyle>
        <NativeFont Name="Microsoft Sans Serif" Size="8.25" Style="Regular" Unit="Point" />
        <ForeColor>WindowText</ForeColor>
        <Location>
          <X>210</X>
          <Y>30</Y>
        </Location>
        <ReadOnly>False</ReadOnly>
        <Size>
          <Width>160</Width>
          <Height>20</Height>
        </Size>
        <TabIndex>1</TabIndex>
        <TabStop>True</TabStop>
        <TextAlign>Left</TextAlign>
        <BindTo Dsc="$4" UpdImm="Y" Brackets="N" />
      </TextBox>
      <Label DsgName="lbl1" Units="0">
        <AutoSize>False</AutoSize>
        <BackColor>ControlLightLight</BackColor>
        <BorderStyle>None</BorderStyle>
        <NativeFont Name="Microsoft Sans Serif" Size="8.25" Style="Regular" Unit="Point" />
        <ForeColor>ControlText</ForeColor>
        <Text LanSpec="N">Name der Anweisung</Text>
        <Location>
          <X>15</X>
          <Y>20</Y>
        </Location>
        <Size>
          <Width>190</Width>
          <Height>35</Height>
        </Size>
        <TabIndex>0</TabIndex>
        <TextAlign>MiddleLeft</TextAlign>
      </Label>
    </GroupBox>
    <PictureBox DsgName="pbx1" Picture="Img:Logo">
      <BackColor>ControlLightLight</BackColor>
      <BorderStyle>None</BorderStyle>
      <ForeColor>ControlText</ForeColor>
      <Location>
        <X>450</X>
        <Y>20</Y>
      </Location>
      <Size>
        <Width>140</Width>
        <Height>65</Height>
      </Size>
      <TabIndex>1</TabIndex>
    </PictureBox>
    <Label DsgName="lbl6" Units="0">
      <AutoSize>False</AutoSize>
      <BackColor>GradientActiveCaption</BackColor>
      <BorderStyle>Fixed3D</BorderStyle>
      <NativeFont Name="Arial" Size="14.25" Style="Italic" Unit="Point" />
      <ForeColor>ControlText</ForeColor>
      <Text LanSpec="N">PRCINI - erstelle Vorlage fr eigene Anweisungen</Text>
      <Location>
        <X>20</X>
        <Y>20</Y>
      </Location>
      <Size>
        <Width>415</Width>
        <Height>65</Height>
      </Size>
      <TabIndex>0</TabIndex>
      <TextAlign>MiddleCenter</TextAlign>
    </Label>
  </Dialog>
</Root>
$TXTEND
